package com.ozs.web.core.util;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.nio.charset.StandardCharsets;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.*;
import java.time.format.DateTimeFormatter;
import java.time.format.DateTimeParseException;
import java.time.temporal.ChronoUnit;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.UUID;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;

import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.jcraft.jsch.Channel;
import com.jcraft.jsch.ChannelExec;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.Session;
import com.ozs.common.utils.HttpClientUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;
import org.springframework.util.ObjectUtils;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ozs.common.config.BaseConfig;
import com.ozs.common.constant.Constants;
import com.ozs.common.core.domain.entity.SysDictData;
import com.ozs.common.core.redis.RedisCache;
import com.ozs.common.exception.base.BaseException;
import com.ozs.common.utils.DateUtils;
import com.ozs.common.utils.HttpClientUtil;
import com.ozs.common.utils.http.HttpUtils;
import com.ozs.framework.config.ServerConfig;
import com.ozs.service.entity.BaseCameraManagement;
import com.ozs.service.entity.BaseDeviceDynamicManagement;
import com.ozs.service.entity.CameraLogDetail;
import com.ozs.service.entity.MqLog;
import com.ozs.service.entity.MsgAlarm;
import com.ozs.service.entity.MsgWebPush;
import com.ozs.service.service.BaseCameraManagementService;
import com.ozs.service.service.BaseDeviceDynamicManagementService;
import com.ozs.service.service.CameraLogDetailService;
import com.ozs.service.service.MqLogService;
import com.ozs.service.service.MsgAlarmService;
import com.ozs.system.mapper.SysDictDataMapper;
import com.ozs.web.core.config.CaneraConfig;
import io.minio.ListObjectsArgs;
import io.minio.MinioClient;
import io.minio.RemoveObjectArgs;
import io.minio.Result;
import io.minio.messages.Item;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;
import org.springframework.util.ObjectUtils;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.io.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.*;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

/**
 * 相机工具
 */

@Configuration
@Slf4j
@Component
public class CameraUtil {

    private static final ExecutorService executor = Executors.newFixedThreadPool(20);

    private static String ffmpegPath;
    private static String filePath;
    private static String transcribeFilePath;
    private static String webUrl;
    private static String bakUrl;
    private static String wsUrl;
    private static CmdCameraUtil cUtil;
    private static RedisCache rc;
    private static ServerConfig sc;
    private static String recordUrl;

    public final static String tsFilekey = "mergeVideoTsFile";

    // 相机配置
    @Autowired
    private CaneraConfig caneraConfig;

    // 命令工具
    @Autowired
    private CmdCameraUtil cmdCameraUtil;

    // 字典
    @Autowired
    private SysDictDataMapper dictDataMapper;

    // redis
    @Autowired
    private RedisCache redisCache;

    // redis
    @Autowired
    private ServerConfig serverConfig;
    @Autowired
    private MsgAlarmService msgAlarmService;

    @Resource
    BaseCameraManagementService baseCameraManagementService;
    @Autowired
    MqLogService mqLogService;
    @Autowired
    BaseDeviceDynamicManagementService baseDeviceDynamicManagementService;

    @Autowired
    CameraLogDetailService cameraLogDetailService;

    @Value("${minio.endpoint}")
    private String endpoint;
    @Value("${minio.accessKey}")
    private String accessKey;
    @Value("${minio.secretKey}")
    private String secretKey;
    @Value("${minio.bucketName}")
    private String bucketName;


    /**
     * 历史回放
     *
     * @param fromVideoFileList
     * @param ph
     * @return
     * @throws IOException
     */
    public static String historyPlay(List<String> fromVideoFileList, String ph, boolean flay) {
        // 视频服务映射路径
        String NewfilePath = BaseConfig.getProfile() + "/" + ph;
        log.info("NewfilePath:{}", NewfilePath);
        log.info("fromVideoFileList:{}", fromVideoFileList);
        if (ObjectUtils.isEmpty(fromVideoFileList) || fromVideoFileList.size() <= 0) {
            throw new BaseException("当前相机无视频录像");
        }
        executor.submit(new Runnable() {
            @Override
            public void run() {
                try {
                    txConvetor(fromVideoFileList, NewfilePath, flay);
                } catch (IOException e) {
                    log.error(e.getMessage());
                    e.printStackTrace();
                }
            }
        });
//        executor.shutdown();

        return Constants.RESOURCE_PREFIX + "/" + ph;
    }

    /**
     * 实时播放的拼接流
     *
     * @param cameraCode 相机编码
     * @param channel    相机通道
     * @return
     */
    public static String getPlayFlv(String cameraCode, String channel, boolean flay, String format) {
        if (!ObjectUtils.isEmpty(format) && "WS-FLV".equals(format)) {
            return wsUrl + "/ws/" + channel + "/" + cameraCode ;
        }
        if (!flay) {
            return webUrl + "/hdl/" + channel + "/" + cameraCode ;
        }
        return webUrl + "/hdl/" + channel + "/" + cameraCode ;
    }

    public static String getPlayFlv(String cameraCode, String channel, String format) {
        return getPlayFlv(cameraCode, channel, true, format);
    }

    public static String getPlayFlv(String cameraCode, String channel, boolean flay) {
        return getPlayFlv(cameraCode, channel, flay, "HTTP-FLV");
    }

    public static String getPlayFlv(String cameraCode, String channel) {
        // WS-FLV     HTTP-FLV
        return getPlayFlv(cameraCode, channel, true, "HTTP-FLV");
    }

    /**
     * 开启录制功能
     *
     * @param cameraCode 相机编码
     * @param channel    相机通道
     * @return
     */
    public static String startRecording(String cameraCode, String channel) {
        return webUrl + "/recordpro/api/start?streamPath=" + channel + "/" + cameraCode;
    }

    /**
     * 关闭录制功能
     *
     * @param taskId 录像接口返回的任务ID
     * @return
     */
    public static String endRecording(String cameraCode, String channel) {
        return webUrl + "/recordpro/api/stop?id=" + cameraCode + "/" + channel + "/flv";
    }


    /**
     * 历史回放流（获取）
     *
     * @param channel 相机通道
     * @param startTm 开始时间
     * @param endTm   结束时间
     * @return
     */
    public static String historyPlayListStr(String channel, Date startTm, Date endTm, boolean flay) {
        List<String> list = filterPlayList(channel, startTm, endTm, filePath);
        String uuid = UUID.randomUUID().toString();
        String ph = "record/flv/" + DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD, new Date())
                + "/" + channel + "/"
                + uuid + ".mp4";
        if (!ObjectUtils.isEmpty(list)) {
            try {
                return historyPlay(list, ph, flay);
            } catch (Exception e) {
                log.error(e.getMessage());
                e.printStackTrace();
            }
        } else {
            throw new BaseException("当前相机无视频录像");
        }
        return null;
    }


    /**
     * 过滤符合条件的视频
     *
     * @param channel
     * @param startTm
     * @param endTm
     * @param mappingUrl
     * @return
     */
    public static List<String> filterPlayList(String channel, Date startTm, Date endTm, String mappingUrl) {
        if (StringUtils.isBlank(channel)
                || ObjectUtils.isEmpty(startTm)
                || ObjectUtils.isEmpty(endTm)) {
            return null;
        }

        List<String> ls = new ArrayList<>();
        Map<Date, String> m = new HashMap<>();
        // 调用视频服务返回参数
        String startTime = DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD, startTm);
        String endTime = DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD, endTm);

        String param = "channel=" + channel + "&startTime=" + startTime + "&endTime=" + endTime;
        String s = HttpUtils.sendGet(bakUrl + "/recordpro/api/list", param);
        // 视频拼接
        if (!StringUtils.isBlank(s) && !"null".equals(s) && !s.startsWith("<!DOCTYPE html>")) {
            List<Map<String, Object>> maps = JSON.parseArray(s, Map.class);
            if (ObjectUtils.isEmpty(maps)) {
                return null;
            }
            for (Map<String, Object> map : maps) {
                Object path = map.get("Path");
                if (!ObjectUtils.isEmpty(path)) {
                    String s1 = path.toString();
                    String substring = s1.substring(s1.lastIndexOf("/") + 1, s1.length());
                    String substring1 = substring.substring(0, substring.indexOf("-"));
                    String[] s2 = substring1.split("_");
                    if (!ObjectUtils.isEmpty(s2)) {

                        String s3 = s2[0] + s2[1];
                        String s4 = s2[0] + s2[2];
                        Date sdate = DateUtils.dateTime(DateUtils.YYYYMMDDHHMMSS, s3);
                        if (s2[1].startsWith("23") && s2[2].startsWith("00")) {
                            sdate = DateUtils.addDays(sdate, -1);
                        }
                        Date edate = DateUtils.dateTime(DateUtils.YYYYMMDDHHMMSS, s4);
                        /*     sdate  |startTm|  edate     |endTm| */
                        if (startTm.compareTo(sdate) >= 0
                                && startTm.compareTo(edate) <= 0
                                && endTm.compareTo(edate) >= 0) {
                            m.put(sdate, mappingUrl + path.toString());
                            /*  |startTm|   sdate    edate   |endTm| */
                        } else if (startTm.compareTo(sdate) <= 0 && endTm.compareTo(edate) >= 0) {
                            m.put(sdate, mappingUrl + path.toString());

                            /*  |startTm|   sdate     |endTm|  edate  */
                        } else if (startTm.compareTo(sdate) <= 0
                                && endTm.compareTo(sdate) >= 0
                                && endTm.compareTo(edate) <= 0) {
                            m.put(sdate, mappingUrl + path.toString());

                            /*  sdate |startTm|      |endTm| edate  */
                        } else if (startTm.compareTo(sdate) >= 0 && endTm.compareTo(edate) <= 0) {
                            m.put(sdate, mappingUrl + path.toString());
                        }
                    }
                }
            }
        }
        if (!ObjectUtils.isEmpty(m) && m.size() > 0) {
            Set<Date> dates = m.keySet();
            // 排序
            dates.stream().parallel().collect(Collectors.toList()).stream().sorted().forEach(d -> {
                ls.add(m.get(d));
            });
            return ls;
        }
        return null;
    }

    /**
     * 合并视频（转化文件）
     *
     * @param fromVideoFileList 视频路径
     * @param newfilePath       生产新的视频文件路径
     * @throws IOException
     */
    public static Map<String, String> myConvetor(List<String> fromVideoFileList,
                                                 String newfilePath,
                                                 String uuid) throws IOException {
        /*
        * for f in *.flv; do echo "file '$f'" >> mylist.txt; done
            ffmpeg -f concat -i mylist.txt -c copy output.flv
        * */

        File file = new File(newfilePath);
        boolean flay = false;
        if (!file.getParentFile().exists()) {
            file.getParentFile().mkdirs();
            log.info("创建文件夹：{}", file.getParentFile().getPath());
            flay = true;
        }
        log.info("newfilePath：{}", newfilePath);


        StringBuffer sm = new StringBuffer("for f in ");
        String pathStr = null;
        for (int t = 0; t < fromVideoFileList.size(); t++) {
            File ft = new File(fromVideoFileList.get(t));
            if (ft.exists()) {
                if (t != fromVideoFileList.size() - 1) {
//                    sm.append(fromVideoFileList.get(t) + " ");
                    sm.append(fromVideoFileList.get(t).substring(fromVideoFileList.get(t).lastIndexOf("/") + 1, fromVideoFileList.get(t).length()) + " ");
                } else {
//                    sm.append(fromVideoFileList.get(t));
                    sm.append(fromVideoFileList.get(t).substring(fromVideoFileList.get(t).lastIndexOf("/") + 1, fromVideoFileList.get(t).length()));
                    pathStr = fromVideoFileList.get(t).substring(0, fromVideoFileList.get(t).lastIndexOf("/"));
                }
            }
        }
//        String substring = newfilePath.substring(0, newfilePath.lastIndexOf("."));
//        substring = substring + ".txt";

        String substring = uuid + ".txt";
        log.info("临时转化的文件：{}", substring);


        sm.append("; do echo \"file '$f'\" >> " + substring + "; done");
        String commit = sm.toString();
        log.info("合并转化文件的命令：{}", commit);
        Process proc = Runtime.getRuntime().exec("/bin/bash", null, null);
        BufferedReader in = new BufferedReader(new InputStreamReader(proc.getInputStream()));
        PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(proc.getOutputStream())), true);

        try {
            String commit1 = ffmpegPath + " -f concat -safe 0 -i " + pathStr + "/" + substring + " -c copy " + newfilePath;

            log.info("合并视频命令：{}", commit1);
            List<String> commands = new ArrayList<>();
            if (flay) {
                commands.add("chomd -R 777 " + file.getParentFile().getPath());
            }
            //
            commands.add("cd " + pathStr);
            // 合并成一个临时文件
            commands.add(commit);

            // 临时文件转化为 flv
//            commands.add(commit1);
            log.info("录像视频命令：{}", commands);
            for (String line : commands) {
                log.info("命令：{}", line);
                out.println(line);
            }
            out.println("exit");// 这个命令必须执行，否则in流不结束。
            log.info("命令：{}", "exit");
            String rspLine = "";
            while ((rspLine = in.readLine()) != null) {
                log.info("*****:{}", rspLine);
            }
            proc.waitFor();
            Map<String, String> map = new HashMap<>();
            map.put("cmd", commit1);
            map.put("path", pathStr + "/" + substring);
            return map;


        } catch (InterruptedException e) {
            log.error(e.getMessage());
            e.printStackTrace();
        } finally {
            in.close();
            out.close();
            proc.destroy();
        }
        return null;
    }


    @SneakyThrows
    public static void txConvetor(List<String> fromVideoFileList,
                                  String newfilePath,
                                  boolean fly) throws IOException {
        /*
        * ffmpeg -i 20230411_155847_155947-d4c2265d-d83e-11ed-8e7f-fa163e4e1e9f.flv -c:v copy 1.ts
ffmpeg -i 20230411_155948_160048-f91fea03-d83e-11ed-8e7f-fa163e4e1e9f.flv -c:v copy 2.ts
ffmpeg -i "concat:1.ts|2.ts" -c copy output.mp4
        * */

        File file = new File(newfilePath);
        boolean flay = false;
        if (!file.getParentFile().exists()) {
            boolean mkdirs = file.getParentFile().mkdirs();
            log.info("创建文件夹：{}", file.getParentFile().getPath());
            log.info("创建文件夹结果：{}", mkdirs);
            flay = true;
        }
        cUtil.cmd("chomd -R 777 " + file.getParentFile().getPath());
        log.info("newfilePath：{}", newfilePath);
        StringBuffer sm = new StringBuffer(ffmpegPath + " -i \"concat:");
        List<String> fileTs = new ArrayList<>();
        for (int t = 0; t < fromVideoFileList.size(); t++) {
            File ft = new File(fromVideoFileList.get(t));
            if (ft.exists()) {
                log.info("file:{}", fromVideoFileList.get(t));
                String substring = fromVideoFileList.get(t).substring(0, fromVideoFileList.get(t).lastIndexOf("."));
                int x;//定义两变量
                Random ne = new Random();//实例化一个random的对象ne
                x = ne.nextInt(9999 - 1000 + 1) + 1000;//为变量赋随机值1000-9999
                substring = substring + x;//定义两变量

                String cmdstr = ffmpegPath + " -i " + fromVideoFileList.get(t) + " -c:v copy " + substring + ".ts";
                log.info("转换命令：{}", cmdstr);
                cUtil.cmd(cmdstr);
                fileTs.add(substring + ".ts");
                if (t != fromVideoFileList.size() - 1) {
                    sm.append(substring + ".ts|");
                } else {
                    sm.append(substring + ".ts\" ");
                }
            }
        }

        if (fileTs.size() > 0) {
            Map<String, Object> mergeVideoTsFile = rc.getCacheMap(tsFilekey);
            if (ObjectUtils.isEmpty(mergeVideoTsFile)) {
                mergeVideoTsFile = new HashMap<>();
            }
            if (!flay) {
                // 如果没有解除，把生成的文件放入要删除的定时任务 redis key 中
                fileTs.add(newfilePath);
            }
            mergeVideoTsFile.put(new Date().getTime() + "", fileTs);
            rc.deleteObject(tsFilekey);
            if (mergeVideoTsFile.size() > 0) {
                rc.setCacheMap(tsFilekey, mergeVideoTsFile);
            }

            sm.append("-c copy " + newfilePath);
            log.info("合并命令：{}", sm.toString());
            cUtil.cmd(sm.toString());
        }

    }

    public static List<Map<String, Object>> getRecordList(String channel, Date startTm, Date endTm) {
        return filterRecordList(channel, startTm, endTm, filePath, recordUrl + "/profile/");
    }

    /**
     * 新的视频服务的回放视频接口
     *
     * @param cameraCode
     * @param channel
     * @param startTm
     * @param endTm
     * @return
     */
    public static String getRecordUrl(String cameraCode, String channel, Date startTm, Date endTm) {
        String result = null;
        log.info(bakUrl + "/gb28181/api/invite?id=" + cameraCode + "&channel=" + channel + "&startTime=" + startTm.getTime()/1000 + "&endTime=" + endTm.getTime()/1000);
        String url = bakUrl + "/gb28181/api/invite?id=" + cameraCode + "&channel=" + channel + "&startTime=" + startTm.getTime()/1000 + "&endTime=" + endTm.getTime()/1000;
        try {
            result = HttpClientUtil.get(url);
            log.info("-----getRecordUrl-----"+result);
            if (result.equals("200")) {
                String path = apiSummary(cameraCode + "/" + channel+"/"+startTm.getTime()/1000+"-"+endTm.getTime()/1000);
                if (StringUtils.isNotEmpty(path)){
                    return path;
                }else {
                    return "当前相机暂无回放视频";
                }
            }
        } catch (Exception e) {
            log.info(e.getMessage());
            e.printStackTrace();
        }
        return "当前相机暂无回放视频";
    }

    /**
     * 调用流媒体获取流列表信息
     *
     * @return
     */
    public static String apiSummary(String path) {
        log.info("---------apiSummary-----"+path);
        int maxRetries = 5;
        int retryCount = 0;
        boolean success = false;
        JSONArray streamArray = null;
        while (!success && retryCount < maxRetries) {
            try {
                String data = HttpClientUtil.gets(bakUrl + "/api/summary");
                log.info("data------------------>" + data);
                if (StringUtils.isNotEmpty(data)) {
                    JSONObject jsonObject = JSONObject.parseObject(data);
                    streamArray = jsonObject.getJSONArray("Streams");
                    success = true;
                }
            } catch (Exception e) {
                log.info("Exception caught: " + e.getMessage());
                // 增加重试计数
                retryCount++;
            }
        }
        log.info("---------streamArray-----"+streamArray);
        if (!ObjectUtils.isEmpty(streamArray)) {
            for (int i = 0; i < streamArray.size(); i++) {
                JSONObject subObj = streamArray.getJSONObject(i);
                String streamPath = subObj.getString("StreamPath");
                log.info("---------streamPath-----"+streamPath);
                if (streamPath.equals(path)) {
                    //取出VideoTracks
                    JSONArray videoJson = subObj.getJSONArray("VideoTracks");
                    log.info("---------videoJson-----"+videoJson);
                    if (videoJson != null && videoJson.size() > 0) {
                        return wsUrl + "/ws/" + streamPath;
                    }
                }
            }
        }
        return null;
    }

    /**
     * 定时任务参数flv文件
     * -----------------------------废弃
     *
     * @throws IOException
     * @throws InterruptedException
     */
    public void deleteFlv() throws IOException, InterruptedException {
        SimpleDateFormat s = new SimpleDateFormat("yyyy-MM-dd");
        Date date = new Date();
        Calendar calendar = new GregorianCalendar();
        calendar.setTime(date);
        calendar.add(calendar.DATE, -1); //把日期往后增加一天,整数  往后推,负数往前移动
        date = calendar.getTime(); //这个时间就是日期往后推一天的结果
        String path = BaseConfig.getProfile() + "/flv/" + DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD, date);
        File file = new File(path);
        if (file.exists()) {
            List<String> rspList = new ArrayList<String>();
            Process proc = Runtime.getRuntime().exec("/bin/bash", null, null);
            BufferedReader in = new BufferedReader(new InputStreamReader(proc.getInputStream()));
            PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(proc.getOutputStream())), true);
            String commit = " rm -rf  " + path;
            List<String> commands = new ArrayList<>();

            // 删除
            commands.add(commit);
            log.info("删除昨天的录像视频命令：{}", commands);
            for (String line : commands) {
                out.println(line);
            }
            out.println("exit");// 这个命令必须执行，否则in流不结束。
            String rspLine = "";
            while ((rspLine = in.readLine()) != null) {
                System.out.println(rspLine);
                rspList.add(rspLine);
            }
            int i = proc.waitFor();
            log.info("执行结果：{}", i);

            in.close();
            out.close();
            proc.destroy();
        }
    }


    /**
     * 定时任务：删除超过配置时长的录制视频
     *
     * @throws IOException
     * @throws InterruptedException
     */
    public void deleteFlvExceed() throws IOException, InterruptedException, ParseException {
        //字典中设置的值
        List<SysDictData> sysCameraRecordTime = dictDataMapper.selectDictDataByType("sys_camera_record_time");

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        Date date = new Date();
        String format = sdf.format(date);
        Calendar calendar = new GregorianCalendar();
        calendar.setTime(sdf.parse(format));
        //正数，日期天数加
        //负数，日期天数减                         提前45天
        if (!ObjectUtils.isEmpty(sysCameraRecordTime)) {
            String dictValue = sysCameraRecordTime.get(0).getDictValue();
            calendar.add(Calendar.DAY_OF_YEAR, Integer.parseInt("-" + dictValue));
        } else {
            calendar.add(Calendar.DAY_OF_YEAR, -45);
        }
        date = calendar.getTime();
        log.info("过期date======================================" + sdf.format(date));
        //遍历每个进行视频录制的摄像头
        File file = new File(transcribeFilePath);
        if (file.exists() && file.isDirectory()) {
            //获取文件夹中所有的子文件夹和文件
            File[] files = file.listFiles();
            if (!ObjectUtils.isEmpty(files) && files.length > 0) {
                for (File file1 : files) {
                    //   file1=/opt/streams/record/flv/34020000001320000167
                    if (file1.exists() && file1.isDirectory()) {
                        //相机文件
                        File[] fs = file1.listFiles();
                        if (!ObjectUtils.isEmpty(fs) && fs.length > 0) {
                            for (File f : fs) {
                                //    f=/opt/streams/record/flv/34020000001320000167/20230328_192033_192037-91509173-cd5a-11ed-8a42-fa163e4e1e9f.flv
                                //fName=20230328_192033_192037-91509173-cd5a-11ed-8a42-fa163e4e1e9f.flv
                                String fName = f.getName();
                                String[] split = fName.split("_");
                                //没有进行分割长度就是1
                                if (split.length > 1) {
                                    //20230328
                                    String s = split[0];
                                    Date parse = sdf.parse(s);
                                    long fTime = parse.getTime();
                                    long dateTime = date.getTime();
                                    //删除过期文件
                                    if (fTime < dateTime) {
                                        log.info("文件过期时间===========================" + dateTime);
                                        log.info("该文件保存时间===========================" + fTime);
                                        f.delete();
                                        log.info("删除过期视频文件===========================" + fName);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }


    public static File[] getCurFilesList(String filePath) {
        File path = new File(filePath);
        File[] listFiles = path.listFiles(new java.io.FileFilter() {

            @Override
            public boolean accept(File pathname) {
                if (pathname.isFile()) {
                    return true;
                } else {

                    return false;
                }
            }
        });

        return listFiles;
    }


    /**
     * 定时任务：关闭录制视频
     *
     * @throws IOException
     * @throws InterruptedException
     */
    public void closeRecording() throws IOException, InterruptedException, ParseException {
        LambdaQueryWrapper<BaseCameraManagement> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(BaseCameraManagement::getStartRecording, 1);
        wrapper.isNotNull(BaseCameraManagement::getTaskId);
        List<BaseCameraManagement> list = baseCameraManagementService.list(wrapper);
        log.info("list======================================" + list);
        List<String> collect = list.stream().map(BaseCameraManagement::getCameraCode).collect(Collectors.toList());
//        List<String> collect = new ArrayList<>();
//        collect.add("42010001541320001116");
        //遍历每个进行视频录制的摄像头
        File file = new File(transcribeFilePath);
        log.info("closeRecording-file.Name()======================================" + file.getName());
        log.info("closeRecording-file.exists()======================================" + file.exists());
        if (file.exists() && file.isDirectory()) {
            //获取文件夹中所有的子文件夹和文件
            File[] files = file.listFiles();
            if (!ObjectUtils.isEmpty(files) && files.length > 0) {
                for (File file1 : files) {
                    log.info("closeRecording-file1---------------" + file1);
                    log.info("closeRecording-cameraCode---------------" + collect);
                    String substring = file1.toString().substring(file1.toString().lastIndexOf("\\") + 1);
                    if (collect.contains(substring)) {
                        File[] files1 = CameraUtil.getCurFilesList(file1.toString());
                        if (!ObjectUtils.isEmpty(files1) && files1.length > 0) {
                            int length = files1.length;
                            File file2 = files1[length - 1];
                            log.info("closeRecording-file2---------------" + file2);
                            String time = file2.toString().substring(file2.toString().lastIndexOf("\\") + 1);
                            String substring1 = time.substring(0, 15);
                            String substring2 = substring1.substring(0, 4);
                            String substring3 = substring1.substring(4, 6);
                            String substring4 = substring1.substring(6, 8);
                            String substring5 = substring1.substring(9, 11);
                            String substring6 = substring1.substring(11, 13);
                            String substring7 = substring1.substring(13, 15);
                            String date = substring2 + "-" + substring3 + "-" + substring4 + " " + substring5 + ":" + substring6 + ":" + substring7;
                            System.out.println(date);
                            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                            Date parse = sdf.parse(date);
                            //当前时间戳
                            long dades = System.currentTimeMillis();
                            //文件的时间戳
                            long time1 = parse.getTime();
                            //当前时间10分钟之前的时间戳
                            long time2 = dades - 600000L;
                            if (time2 <= time1 && time1 < dades) {
                            } else {
                                LambdaQueryWrapper<BaseCameraManagement> lw = new LambdaQueryWrapper<BaseCameraManagement>();
                                lw.eq(BaseCameraManagement::getCameraCode, substring);
                                BaseCameraManagement baseCameraManagement = baseCameraManagementService.getOne(lw);
                                log.info("closeRecording-endRecording------------" + baseCameraManagement.getTaskId());
                                String start = HttpUtils.sendGet(CameraUtil.endRecording(baseCameraManagement.getCameraCode(), baseCameraManagement.getChannel()));
                                log.info("closeRecording-endRecording------------" + start);
                                if ("success".equals(start)) {
                                    baseCameraManagement.setStartRecording(2);
                                    baseCameraManagement.setTaskId("");
                                } else {
                                    baseCameraManagement.setStartRecording(2);
                                    baseCameraManagement.setTaskId("");
                                    log.error("关闭视频录制异常日志如下:" + start);
                                }
                                baseCameraManagementService.updateById(baseCameraManagement);
                            }
                        } else {
                            LambdaQueryWrapper<BaseCameraManagement> lw = new LambdaQueryWrapper<BaseCameraManagement>();
                            lw.eq(BaseCameraManagement::getCameraCode, substring);
                            BaseCameraManagement baseCameraManagement = baseCameraManagementService.getOne(lw);
                            log.info("closeRecording-endRecording------------" + baseCameraManagement.getTaskId());
                            String start = HttpUtils.sendGet(CameraUtil.endRecording(baseCameraManagement.getCameraCode(), baseCameraManagement.getChannel()));
                            log.info("closeRecording-endRecording------------" + start);
                            if ("success".equals(start)) {
                                baseCameraManagement.setStartRecording(2);
                                baseCameraManagement.setTaskId("");
                            } else {
                                baseCameraManagement.setStartRecording(2);
                                baseCameraManagement.setTaskId("");
                                log.error("关闭视频录制异常日志如下:" + start);
                            }
                            baseCameraManagementService.updateById(baseCameraManagement);
                        }
                    }
                }
            }
        }
    }

    /**
     * 旧的视频回放的接口
     *
     * @param channel
     * @param startTm
     * @param endTm
     * @param mappingUrl
     * @param wUrl
     * @return
     */
    public static List<Map<String, Object>> filterRecordList(String channel,
                                                             Date startTm,
                                                             Date endTm,
                                                             String mappingUrl,
                                                             String wUrl) {
        List<Map<String, Object>> rmaps = new ArrayList<>();

        if (StringUtils.isBlank(channel)
                || ObjectUtils.isEmpty(startTm)
                || ObjectUtils.isEmpty(endTm)) {
            log.info("channel-----"+channel+"----startTm"+startTm+"-----endTm"+endTm);
            return null;
        }
        Map<Date, Map<String, Object>> m = new HashMap<>();
        // 调用视频服务返回参数
        String startTime = DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD, startTm);
        String endTime = DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD, endTm);

        String param = "channel=" + channel + "&startTime=" + startTime + "&endTime=" + endTime;
        // /api/record/flv/list
        String s = HttpUtils.sendGet(bakUrl + "/recordpro/api/list", param);
        // 视频拼接
        log.info("视频拼接s-----"+s);
        if (!StringUtils.isBlank(s) || "null".equals(s)) {
            List<Map<String, Object>> maps = JSON.parseArray(s, Map.class);
            if (ObjectUtils.isEmpty(maps)) {
                log.info("maps-----"+maps);
                return null;
            }
            for (Map<String, Object> map : maps) {
                Object path = map.get("Path");
                Object size = map.get("Size");
                Object duration = map.get("Duration");
                if (!ObjectUtils.isEmpty(path)) {
                    String s1 = path.toString();
                    String substring = s1.substring(s1.lastIndexOf("/") + 1, s1.length());
                    String substring1 = substring.substring(0, substring.indexOf("-"));
                    String[] s2 = substring1.split("_");
                    if (!ObjectUtils.isEmpty(s2)) {
                        Map<String, Object> mo = new HashMap<>();

                        String s3 = s2[0] + s2[1];
                        String s4 = s2[0] + s2[2];
                        Date sdate = DateUtils.dateTime(DateUtils.YYYYMMDDHHMMSS, s3);
                        if (s2[1].startsWith("23") && s2[2].startsWith("00")) {
                            sdate = DateUtils.addDays(sdate, -1);
                        }
                        Date edate = DateUtils.dateTime(DateUtils.YYYYMMDDHHMMSS, s4);
                        mo.put("startTime", DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD_HH_MM_SS, sdate));
                        mo.put("entTime", DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD_HH_MM_SS, edate));
                        mo.put("url", wUrl + path.toString());
                        mo.put("path", mappingUrl + path.toString());
                        mo.put("fileName", substring);
                        mo.put("size", size);
                        mo.put("duration", duration);
                        /*     sdate  |startTm|  edate     |endTm| */
                        if (startTm.compareTo(sdate) >= 0
                                && startTm.compareTo(edate) <= 0
                                && endTm.compareTo(edate) >= 0) {
                            m.put(sdate, mo);
                            /*  |startTm|   sdate    edate   |endTm| */
                        } else if (startTm.compareTo(sdate) <= 0 && endTm.compareTo(edate) >= 0) {
                            m.put(sdate, mo);

                            /*  |startTm|   sdate     |endTm|  edate  */
                        } else if (startTm.compareTo(sdate) <= 0
                                && endTm.compareTo(sdate) >= 0
                                && endTm.compareTo(edate) <= 0) {
                            m.put(sdate, mo);

                            /*  sdate |startTm|      |endTm| edate  */
                        } else if (startTm.compareTo(sdate) >= 0 && endTm.compareTo(edate) <= 0) {
                            m.put(sdate, mo);
                        }
                    }
                }
            }
        }
        if (!ObjectUtils.isEmpty(m) && m.size() > 0) {
            Set<Date> dates = m.keySet();
            // 排序
            dates.stream().parallel().collect(Collectors.toList()).stream().sorted().forEach(d -> {

                rmaps.add(m.get(d));
            });
            log.info("rmaps:{}", rmaps);
            return rmaps;
        }
        return null;
    }

    @PostConstruct
    public void init() {
        ffmpegPath = caneraConfig.getFfmpegPath();
        filePath = caneraConfig.getFilePath();
        transcribeFilePath = caneraConfig.getTranscribeFilePath();
        webUrl = caneraConfig.getWebUrl();
        bakUrl = caneraConfig.getBakUrl();
        cUtil = cmdCameraUtil;
        rc = redisCache;
        sc = serverConfig;
        wsUrl = caneraConfig.getWsUrl();
        recordUrl = caneraConfig.getRecordUrl();
    }


    /**
     * 定时合成视频
     * ----------------------------废弃
     */
    public void mergeVideo() {
        List<MsgAlarm> msgAlarms = msgAlarmService.queryAlarmInfoByAfterTenMinute();
        if (!ObjectUtils.isEmpty(msgAlarms)) {
            for (MsgAlarm msgAlarm : msgAlarms) {
                // 表示已经超过报警时间10分钟，且没有解除报警、也没有报警Url 的可以合成视频
                Map<String, Object> map = baseCameraManagementService.getCameraChannelByAlarmId(msgAlarm.getAlarmId());
                if (!StringUtils.isBlank(map.get("channel").toString())) {
                    log.info("报警UUID:{},相机通道：{},开始时间：{}，结束时间：{}", msgAlarm.getAlarmId(), map.get("channel").toString(), msgAlarm.getAlarmTime(), new Date());
                    try {
                        String url = historyPlayListStr(map.get("channel").toString(), msgAlarm.getAlarmTime(), new Date(), false);
                        MsgAlarm byId = msgAlarmService.getById(msgAlarm.getId());
                        byId.setReleasedUrl(url);
                        msgAlarmService.updateById(byId);
                    } catch (Exception e) {
                        log.error("mergeVideo error:", e.getMessage());
                    }
                }
            }
        }
    }


    /**
     * 删除生成的临时文件  30分钟后
     */
    public void deleteTsFile() {
        Date date = new Date();
        List<String> keys = new ArrayList<>();
        Calendar calendar = new GregorianCalendar();
        Map<String, Object> mergeVideoTsFile = redisCache.getCacheMap("mergeVideoTsFile");
        if (!ObjectUtils.isEmpty(mergeVideoTsFile) && mergeVideoTsFile.size() > 0) {
            mergeVideoTsFile.keySet().forEach(s -> {
                Object o = mergeVideoTsFile.get(s);
                Date fileTime = new Date(Long.parseLong(s));
                calendar.setTime(fileTime);
                calendar.add(calendar.MINUTE, 30); //把日期往后增加30分钟,整数  往后推,负数往前移动
                fileTime = calendar.getTime(); //这个时间就是日期往后推一天的结果
                if (date.compareTo(fileTime) > 0) {
                    List<String> list = (List<String>) o;
                    for (String s1 : list) {
                        File ft = new File(s1);
                        if (ft.exists()) {
                            ft.delete();
                        }
                    }
                    //
                    keys.add(s);
                }
            });

            if (keys.size() > 0) {
                for (String s : keys) {
                    mergeVideoTsFile.remove(s);
                }
            }
        }
        log.info("mergeVideoTsFile:{}", mergeVideoTsFile);
        redisCache.deleteObject("mergeVideoTsFile");
        if (mergeVideoTsFile.size() > 0) {
            redisCache.setCacheMap("mergeVideoTsFile", mergeVideoTsFile);
        }

    }

    /**
     * 相机状态修改
     */
    public void cameraBlockUp() {
        long time=60000L;
        //当前时间戳
        long dades = System.currentTimeMillis();
        //字典中设置的值
        List<SysDictData> heartIntervalTime = dictDataMapper.selectDictDataByType("heart_interval_time");
        List<SysDictData> triggerWarningFrequency = dictDataMapper.selectDictDataByType("trigger_warning_frequency");
        if (!ObjectUtils.isEmpty(heartIntervalTime)){
            time=time*Long.valueOf(heartIntervalTime.get(0).getDictValue());
        }
        if (!ObjectUtils.isEmpty(triggerWarningFrequency)){
            time=time*Long.valueOf(triggerWarningFrequency.get(0).getDictValue());
        }
        if (ObjectUtils.isEmpty(heartIntervalTime)||ObjectUtils.isEmpty(triggerWarningFrequency)){
            time=time*5*3;
        }
        //当前时间5分钟之前的时间戳
        long time2 = dades - (time);
        LambdaQueryWrapper<MqLog> mqLog = new LambdaQueryWrapper<>();
        mqLog.ge(MqLog::getCreateTime, new Date(time2));
        mqLog.le(MqLog::getCreateTime, new Date(dades));
        List<MqLog> list = mqLogService.list(mqLog);
        List<String> log = list.stream().map(MqLog::getCameraCode).collect(Collectors.toList());
        List<BaseDeviceDynamicManagement> dynamicManagements = baseDeviceDynamicManagementService.list();
        List<String> base = dynamicManagements.stream().map(BaseDeviceDynamicManagement::getCameraCode).collect(Collectors.toList());
        if (!ObjectUtils.isEmpty(log)) {
            //找出相机表中不包含日志表相机的数据
            List<BaseDeviceDynamicManagement> ones = dynamicManagements.stream().filter(o -> !log.contains(o.getCameraCode())).collect(Collectors.toList());
            List<String> collect = ones.stream().map(BaseDeviceDynamicManagement::getCameraCode).collect(Collectors.toList());
            //找出相机表中包含日志表相机的数据
            base.retainAll(log);
            LambdaUpdateWrapper<BaseDeviceDynamicManagement> queryWrapper = new LambdaUpdateWrapper<>();
            queryWrapper.in(BaseDeviceDynamicManagement::getCameraCode, base);
            queryWrapper.set(BaseDeviceDynamicManagement::getIsDisable, 1);
            baseDeviceDynamicManagementService.saveOrUpdate(null, queryWrapper);

            LambdaUpdateWrapper<BaseDeviceDynamicManagement> wrapper = new LambdaUpdateWrapper<>();
            wrapper.in(BaseDeviceDynamicManagement::getCameraCode, collect);
            wrapper.set(BaseDeviceDynamicManagement::getIsDisable, 2);
            baseDeviceDynamicManagementService.saveOrUpdate(null, wrapper);
        }else {
            LambdaUpdateWrapper<BaseDeviceDynamicManagement> wrapper = new LambdaUpdateWrapper<>();
            wrapper.in(BaseDeviceDynamicManagement::getCameraCode, base);
            wrapper.set(BaseDeviceDynamicManagement::getIsDisable, 2);
            baseDeviceDynamicManagementService.saveOrUpdate(null, wrapper);
        }
    }

    /**
     * MQTT超时监测
     */
    public void updateCameraLogDetail() {
        LambdaQueryWrapper<CameraLogDetail> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(CameraLogDetail::getStatus, 2);
        List<CameraLogDetail> list = cameraLogDetailService.list();
        //当前时间戳
        long dades = System.currentTimeMillis();
        for (CameraLogDetail cameraLogDetail : list) {
            //文件的时间戳
            long time1 = cameraLogDetail.getUpdateTime().getTime();
            //当前时间1分钟之前的时间戳
            if (dades - time1 > 60000L) {
                cameraLogDetail.setStatus(3);
                cameraLogDetail.setRemark("MQ接收消息超时");
                cameraLogDetailService.updateById(cameraLogDetail);
            }
        }

    }

    /**
     * 修改相机状态
     */
    public void updateCameraManagementState() {
        //离线的
        ArrayList<String> offLine = new ArrayList<>();
        List<BaseDeviceDynamicManagement> list = baseDeviceDynamicManagementService.list();
        for (BaseDeviceDynamicManagement baseDeviceDynamicManagement : list) {
            // 格式化输入时间
            DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
            Instant instant = baseDeviceDynamicManagement.getUpdateTime().toInstant();
            // 将Instant对象转换为LocalDateTime对象
            LocalDateTime localDateTime = instant.atZone(ZoneId.systemDefault()).toLocalDateTime();


            // 获取当前时间
            LocalDateTime currentTime = LocalDateTime.now();

            // 计算时间差
            Duration duration = Duration.between(localDateTime, currentTime);

            // 检查时间差是否大于3小时
            if (duration.toHours() >= 3) {
                offLine.add(baseDeviceDynamicManagement.getCameraCode());
            }
        }
        //修改离线相机
        if (!ObjectUtils.isEmpty(offLine)) {
            LambdaUpdateWrapper<BaseDeviceDynamicManagement> updateWrapper = Wrappers.lambdaUpdate();
            updateWrapper.in(BaseDeviceDynamicManagement::getCameraCode, offLine);

            // 执行批量修改操作
            BaseDeviceDynamicManagement update = new BaseDeviceDynamicManagement();
            update.setIsDisable(2);
            update.setFacilityState(2);
            baseDeviceDynamicManagementService.update(update, updateWrapper);
        }

        //修改在线相机
        LambdaUpdateWrapper<BaseDeviceDynamicManagement> wrapper = Wrappers.lambdaUpdate();
        if (!ObjectUtils.isEmpty(offLine)) {
            wrapper.notIn(BaseDeviceDynamicManagement::getCameraCode, offLine);
        }

        // 执行批量修改操作
        BaseDeviceDynamicManagement baseDeviceDynamicManagement = new BaseDeviceDynamicManagement();
        baseDeviceDynamicManagement.setIsDisable(1);
        baseDeviceDynamicManagement.setFacilityState(2);
        baseDeviceDynamicManagementService.update(baseDeviceDynamicManagement, wrapper);
    }

    /**
     * 删除录制视频的零时文件
     */
    public void deleteTmpFlv(String num) {
        log.info("find /opt/streams/record/flv/*/*/ -mmin +5 -name *.flv -exec rm -rf {} \\;");
//        cmdCameraUtil.cmd("find /opt/streams/record/flv/*/*/ -mmin +5 -name *.flv -exec rm -rf {} \\;");

        try {
            Process proc = Runtime.getRuntime().exec("/bin/bash", null, null);
            BufferedReader in = new BufferedReader(new InputStreamReader(proc.getInputStream()));
            PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(proc.getOutputStream())), true);
            String commit = "find /opt/streams/record/flv/*/*/ -mmin +" + num + " -name *.flv -exec rm -rf {} \\;";
//              String commit = "find /opt/streams/record/flv/*/*/ -mmin +1 -name *.flv -exec rm -rf {} \\;";
            List<String> commands = new ArrayList<>();

            // 删除
            commands.add(commit);
            log.info("删除昨天的录像视频命令：{}", commands);
            for (String line : commands) {
                out.println(line);
            }
            out.println("exit");// 这个命令必须执行，否则in流不结束。
            String rspLine = "";
            while ((rspLine = in.readLine()) != null) {
                System.out.println(rspLine);

            }
            int i = proc.waitFor();
            log.info("执行结果：{}", i);

            in.close();
            out.close();
            proc.destroy();
        } catch (IOException e) {
            log.error(e.getMessage());
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

    }


    /**
     * 重启流媒体
     */
    public void restart() {
        log.info("restart=============");
        try {
            Process proc = Runtime.getRuntime().exec("/bin/bash", null, null);
            BufferedReader in = new BufferedReader(new InputStreamReader(proc.getInputStream()));
            PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(proc.getOutputStream())), true);
            String commit = "sh /opt/streams/restartStreams.sh";
            List<String> commands = new ArrayList<>();

            // 删除
            commands.add(commit);
            for (String line : commands) {
                out.println(line);
            }
            out.println("exit");// 这个命令必须执行，否则in流不结束。
            String rspLine = "";
            while ((rspLine = in.readLine()) != null) {
                System.out.println(rspLine);

            }
            int i = proc.waitFor();
            log.info("执行结果：{}", i);

            in.close();
            out.close();
            proc.destroy();
        } catch (IOException e) {
            log.error(e.getMessage());
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

    }


    public void removePrice(Integer number,String path) {
        log.info("removePrice-----------开始调用");
        log.info("removePrice------number-----"+number);
        log.info("removePrice-------path----"+path);
        try {
            // 创建MinioClient对象
            MinioClient minioClient = MinioClient.builder()
                    .endpoint(endpoint)
                    .credentials(accessKey, secretKey)
                    .build();

            // 指定要删除文件的桶名和目录名
            String bucketName = this.bucketName;
            String prefix = "camera_picture/normal/"+path;
            log.info("removePrice-------prefix----"+prefix);
            // 指定要删除的时间点（此处为当前时间之前的时间）
            ZonedDateTime deleteTime = ZonedDateTime.now().minusDays(number); // 删除90天前的文件

            // 删除指定目录下的所有文件和文件夹
            deleteObjectsAndEmptyDirectoriesRecursively(minioClient, bucketName, prefix, deleteTime);
        } catch (Exception e) {
            System.out.println("Error occurred: " + e);
        }
    }

    private static void deleteObjectsAndEmptyDirectoriesRecursively(MinioClient minioClient, String bucketName, String prefix, ZonedDateTime deleteTime) throws Exception {
        Iterable<Result<Item>> results = minioClient.listObjects(ListObjectsArgs.builder().bucket(bucketName).prefix(prefix).recursive(true).build());
        for (Result<Item> result : results) {
            Item item = result.get();
            ZonedDateTime itemLastModified = item.lastModified();
            log.info("删除的时间:" + deleteTime);
            log.info("文件名称: " + item.objectName());
            log.info("文件夹的时间:" + itemLastModified);
            if (itemLastModified.isBefore(deleteTime)) {
                // 删除文件或文件夹
                minioClient.removeObject(RemoveObjectArgs.builder()
                        .bucket(bucketName)
                        .object(item.objectName())
                        .build());
                log.info("删除文件或文件夹: " + item.objectName());
            }
        }
    }


    public void test() {
        try {
            // Initialize Minio client
            MinioClient minioClient = MinioClient.builder()
                    .endpoint(endpoint)
                    .credentials(accessKey, secretKey)
                    .build();

            // Bucket name
            String bucketName = this.bucketName;
            String prefix = "camera_picture/normal/";
            // List all objects in the bucket
            Iterable<Result<Item>> results = minioClient.listObjects(ListObjectsArgs.builder().bucket(bucketName).prefix(prefix).recursive(true).build());
            log.info("-------获取minio所有图片--------"+results);
            for (Result<Item> result : results) {
                Item item = result.get();
                log.info("----item.lastModified()----"+item.lastModified());
                log.info(item.objectName());
            }
        } catch (Exception e) {
            log.error("Error occurred: " + e);
        }
    }

//    public void removePrice() {
//        String host = "10.161.12.52"; // 远程主机
//        String user = "root"; // SSH用户名
//        String password = "iTi*21116"; // SSH密码
//
//        try {
//            JSch jsch = new JSch();
//            Session session = jsch.getSession(user, host, 22); // 默认SSH端口号是22
//            session.setConfig("StrictHostKeyChecking", "no"); // 不进行主机密钥检查
//            session.setPassword(password);
//            session.connect();
//
//            String remoteDir = "/data/minio/data/picbucket/camera_picture/normal/"; // 要查看的远程目录
//
//            Channel channel = session.openChannel("exec");
//            ((ChannelExec) channel).setCommand("ls " + remoteDir); // 在远程服务器上执行第一次`ls`命令
//            InputStream in = channel.getInputStream();
//            channel.connect();
//            BufferedReader reader = new BufferedReader(new InputStreamReader(in));
//            String line;
//            //第一次命令输出
//            while ((line = reader.readLine()) != null) {
//                StringBuilder commandOutput = new StringBuilder(); // 存储命令输出
//                commandOutput.append(remoteDir);
//                System.out.println(line);
//                commandOutput.append(line);
//
//                // 执行第二次命令输出
//                Channel channel2 = session.openChannel("exec");
//                ((ChannelExec) channel2).setCommand("ls " + commandOutput.toString()); // 在远程服务器上执行第二次`ls`命令
//                InputStream in2 = channel2.getInputStream();
//                channel2.connect();
//
//                BufferedReader reader2 = new BufferedReader(new InputStreamReader(in2));
//                while ((line = reader2.readLine()) != null) {
//                    System.out.println(line); // 输出第二次`ls -l`的结果
//                    commandOutput.append("/" + line);
//
//                    // 执行第三次命令输出
//                    Channel channel3 = session.openChannel("exec");
//                    ((ChannelExec) channel3).setCommand("ls " + commandOutput.toString()); // 在远程服务器上执行第三次`ls`命令
//                    InputStream in3 = channel3.getInputStream();
//                    channel3.connect();
//
//                    BufferedReader reader3 = new BufferedReader(new InputStreamReader(in3));
//                    while ((line = reader3.readLine()) != null) {
//                        System.out.println(line); // 输出第三次`ls -l`的结果
//                        commandOutput.append("/" + line);
//
//                        // 执行第四次命令输出
//                        Channel channel4 = session.openChannel("exec");
//                        ((ChannelExec) channel4).setCommand("ls " + commandOutput.toString()); // 在远程服务器上执行第四次`ls`命令
//                        InputStream in4 = channel4.getInputStream();
//                        channel4.connect();
//
//                        BufferedReader reader4 = new BufferedReader(new InputStreamReader(in4));
//                        while ((line = reader4.readLine()) != null) {
//                            System.out.println(line); // 输出第四次`ls -l`的结果
//                            commandOutput.append("/" + line);
//                            // 执行第五次命令输出
//                            Channel channel5 = session.openChannel("exec");
//                            ((ChannelExec) channel5).setCommand("ls -l " + commandOutput.toString()); // 在远程服务器上执行第五次`ls`命令
//                            InputStream in5 = channel5.getInputStream();
//                            channel5.connect();
//
//                            BufferedReader reader5 = new BufferedReader(new InputStreamReader(in5));
//                            while ((line = reader5.readLine()) != null) {
//                                System.out.println(line);// 输出第五次`ls -l`的结果
//                                Pattern pattern = Pattern.compile("\\S+$"); // 匹配最后一个非空白字符之后的内容，即文件名
//                                Matcher matcher = pattern.matcher(line);
//                                if (matcher.find()) {
//                                    long date = getDate(line, matcher.group());
//                                    System.out.println(matcher.group());
//                                    if ((int) date <= -7) {
//                                        //执行删除
//                                        System.out.println("执行删除：" + date);
//                                        Channel channel6 = session.openChannel("exec");
//                                        System.out.println("参数" + commandOutput + "/" + matcher.group());
//                                        ((ChannelExec) channel6).setCommand("rm -rf " + commandOutput + "/" + matcher.group());
//                                        InputStream in6 = channel6.getInputStream();
//                                        channel6.connect();
//                                    }
//                                }
//                            }
//                            channel5.disconnect();
//                            commandOutput.setLength(commandOutput.length() - 1);
//                        }
//                        channel4.disconnect();
//                        commandOutput.setLength(commandOutput.length() - 1);
//                    }
//                    channel3.disconnect();
//                    commandOutput.setLength(commandOutput.length() - 1);
//
//                }
//                channel2.disconnect();
//                commandOutput.setLength(commandOutput.length() - 1);
//            }
//            channel.disconnect();
//            session.disconnect();
//        } catch (JSchException | java.io.IOException e) {
//            System.out.println(e);
//        }
//    }
//
//    public static long getDate(String text, String two) {
//
//        // 使用空格分割字符串
//        String[] parts = text.split(" ");
//
//        for (int i = 0; i < parts.length - 2; i++) {
//            // 检查当前部分和下一个部分是否符合Linux系统时间的格式
//            if (parts[i].matches("[A-Z][a-z]{2}")) {
//                String linuxTime = parts[i] + " " + two;
//                System.out.println("Linux系统时间: " + linuxTime);
//                // 指定一个默认的年份
//                String year = String.valueOf(LocalDate.now().getYear());
//
//                try {
//                    // 解析日期字符串并转换为LocalDate对象
//                    LocalDate date = parseDate(linuxTime, year);
//                    System.out.println("Converted date: " + date);
//                    // 当前时间
//                    // 计算日期之间的天数差异
//                    LocalDate currentDate = LocalDate.now();
//                    long daysDiff = ChronoUnit.DAYS.between(currentDate, date);
//                    System.out.println("Days difference with current date: " + daysDiff);
//                    return daysDiff;
//                } catch (DateTimeParseException e) {
//                    System.out.println("Error parsing date: " + e.getMessage());
//                }
//                break;
//            }
//        }
//        return 0;
//    }
//
//    private static LocalDate parseDate(String dateStr, String defaultYear) {
//        // 创建一个月份缩写到数字的映射
//        Map<String, String> monthMap = new HashMap<>();
//        monthMap.put("Jan", "01");
//        monthMap.put("Feb", "02");
//        monthMap.put("Mar", "03");
//        monthMap.put("Apr", "04");
//        monthMap.put("May", "05");
//        monthMap.put("Jun", "06");
//        monthMap.put("Jul", "07");
//        monthMap.put("Aug", "08");
//        monthMap.put("Sep", "09");
//        monthMap.put("Oct", "10");
//        monthMap.put("Nov", "11");
//        monthMap.put("Dec", "12");
//
//        // 将月份缩写替换为数字
//        String[] dateParts = dateStr.split(" ");
//        String month = monthMap.get(dateParts[0]);
//        String day = dateParts[1];
//        int num = Integer.parseInt(day);
//        if (num >= 1 && num <= 9) {
//            day = "0" + day;
//        }
//        String fullDateStr = month + " " + day + " " + defaultYear;
//
//        // 使用DateTimeFormatter解析日期
//        return LocalDate.parse(fullDateStr, DateTimeFormatter.ofPattern("MM dd yyyy"));
//    }
}
